const BASE_URL = 'https://lands-api.ogundev.com.ng/api/v1/';
const WS_URL = 'https://martforte.pusher.com:8555/auth';

function authHeader(){return{"Content-Type":"application/json",Accept:"application/json",Authorization:"Bearer "+localStorage.getItem("token")}}
async function logout(){await localStorage.setItem("redirect_url",window.location.href),await localStorage.removeItem("token"),window.location.href=await"/account/login"}
//function handleResponsee(t){return t.text().then(async o=>{if(!t.ok)return 401===t.status?t.url===`${BASE_URL}auth/customer`||t.url===`${BASE_URL}auth/signup`||logout():418===t.status?(window.location.href="/account/profile#unverified"):t.status,Promise.reject(JSON.parse(o));const e=o&&JSON.parse(o);return e})}
async function login(t){await localStorage.setItem("token",t);const o=localStorage.getItem("redirect_url");window.location.href=await o?o:"/account/profile"}

function formatCurrency(t,r){if("null"!=t&&"0"!=t){let e;return(e=Number.isInteger(t)?t.toFixed(2).toString().split("."):Number(t).toFixed(2).toString().split("."))[0]=e[0].replace(/\B(?=(\d{3})+(?!\d))/g,","),(r?"₦":"")+e.join(".")}return(r?"₦":"")+"0"}

function optArr(e,o,n,t,r){document.querySelectorAll("#"+e+" option").forEach(e=>e.remove()),byId(e).innerHTML=r?"<option selected disabled value>"+(!0!==r?r:"")+"</option>":"",o.forEach(o=>{const r=document.createElement("option");r.value=n?o[n]:o,r.innerHTML=t?o[t]:o,byId(e).add(r)})}

function queryUrl(e){return e?JSON.parse('{"'+e.substring(1).replace(/"/g,'\\"').replace(/&/g,'","').replace(/=/g,'":"')+'"}'):{}}

let lgas = ['Abeokuta North', 'Abeokuta South', 'Ado-Odo/Ota', 'Ewekoro', 'Ifo', 'Ijebu East', 'Ijebu North', 'Ijebu North East', 'Ijebu Ode', 'Ikenne', 'Imeko Afon', 'Ipokia', 'Obafemi Owode', 'Odogbolu', 'Odeda', 'Ogun Waterside', 'Remo North', 'Sagamu (Shagamu)', 'Yewa North (formerly Egbado North)', 'Yewa South (formerly Egbado South)']

let prp_land_use = [{id:1,name:'Residential'},{id:2,name:'Commercial'}];

function handleResponse(response){
    return response.text().then(async text => {
        if (!response.ok) {
            if (response.status === 401) {
                if(!response.url.includes('auth/customer')){
                    logout();
                }
            } else if (response.status === 403) {
                if(!response.url.includes('auth/customer')){
                    logout();
                }
            } else if (response.status === 418) {
                window.location.href="/account/profile#unverified";
            }
            return Promise.reject(JSON.parse(text));
        } 
        const data = text && JSON.parse(text);
        return data;
  }).catch(e => {return Promise.reject(e);});
}

function printDiv(pTitle) {
    var headstr = "<html><head><title></title></head><body><h3>"+pTitle+"</h3>";
    var footstr = "</body>";
    var newstr = document.getElementById('print-div').innerHTML;
    var oldstr = document.body.innerHTML;
    document.body.innerHTML = headstr+newstr+footstr;
    window.print();
    window.onfocus=function(){ window.location.reload();}
    document.body.innerHTML = oldstr;
    return false;
}

function parseJwt (token) {
    var base64Url = token.split('.')[1];
    var base64 = base64Url.replace(/-/g, '+').replace(/_/g, '/');
    var jsonPayload = decodeURIComponent(atob(base64).split('').map(function(c) {
        return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
    }).join(''));

    return JSON.parse(jsonPayload);
};

async function fetchAuth(runFn, runArgs, retryFn){
    const token = localStorage.getItem('token');

    if(token){
        if(parseJwt(token)){
            const tk = parseJwt(token);

            if((tk.exp-900)*1000>Date.now()){
                runFn(runArgs);
            } else if((tk.exp+1209500)*1000>Date.now()) {
                const requestOptions = {
                    method: 'GET',
                    headers: authHeader()
                };
                let res = await fetch(BASE_URL+'auth/customer_refresh', requestOptions).then(handleResponse).catch(e => { if(e&&e.message=='Server Error') logout();});
                if(res) {await localStorage.setItem('token',res.token);
                let req = await fetch(BASE_URL+'auth/get_customer', {method: 'GET', headers: {...authHeader(), Authorization: "Bearer "+res.token}}).then(handleResponse);
                await runFn(runArgs);}
            } else {console.log('3');
                logout();
            }
        } else {
            logout();
        }
    } else {
        logout();
    }
}

function errorOk({title = 'Error', text = 'Check your internet connection'}){
  Swal.fire({
    title,
    text,
    icon:"error",
    confirmButtonColor:"grey",
    confirmButtonText:"Ok",
    //allowOutsideClick: false
  });
}

function successOk({title = 'Success', text = 'Your request completed successfully.',retry}){
  Swal.fire({
    title,
    text,
    icon:"success",
    confirmButtonColor:"grey",
    confirmButtonText:"Ok",
    allowOutsideClick: false
  }).then((e) => {
    if(e.isConfirmed) retry?retry():window.location.reload();
  });
}

function runIt(){}

async function fetchX(url, options){
  const auth = await fetchAuth(runIt);
  const response = await fetch(url, {...options, headers: authHeader()});
  return await response;
}

var addFunctionOnWindowLoad = function(callback){
    if(window.addEventListener){
        window.addEventListener('load',callback,false);
    } else {
        window.attachEvent('onload',callback);
    }
}